#ifndef _dstring_H_
#define _dstring_H_

class dstring
{
   //-----------------------------------------------------------------------
   // Member-Variablen, nach Mvglichkeit immer PRIVATE !
   //-----------------------------------------------------------------------
   private:
      char *ptr;

   //-----------------------------------------------------------------------
   // (Methoden) Member-Funktionen
   //-----------------------------------------------------------------------
   private:
      long len (char *tocount) const;

   public:
      //--------------------------------------------------------------------
      // Constructoren und Destructor
      //--------------------------------------------------------------------
       dstring ();	// Constructor
       dstring (char *toset);
       dstring (dstring & toset);
      ~dstring ();

      //--------------------------------------------------------------------
      // Methoden
      //--------------------------------------------------------------------
      char *get     (void)          const {return (ptr);};
      char *set     (char *toset);
      long  length  (void) const {return (len (ptr));};
      char *concat  (char *toadd);
      char *lower   (void);
      char *upper   (void);
      char *ltrim   (void);
      char *rtrim   (void);
      char *alltrim (void);

      //-------------------------------------------------------------------
		// Rckgaben aus dem gespeicherten Text
      //-------------------------------------------------------------------
      float       GetFloat      (int Offset = 0);
      double      GetDouble     (int Offset = 0);
      long double GetLongDouble (int Offset = 0);
      int         GetInt        (int Offset = 0);

      //-------------------------------------------------------------------
      // OPERATOREN 
      // Achtung:  der Zuweisungsoperator = sollte immer berladen werden!
      //-------------------------------------------------------------------
      char *operator=  (dstring & tocopy);
      char *operator=  (char *tocopy);
      char *operator+  (dstring & tocopy);
      char *operator+  (char *tocopy);

      //-------------------------------------------------------------------
      // Vergleichsoperatoren
      //-------------------------------------------------------------------
      int operator== (char *tocheck);
      int operator== (dstring & tocheck) {return (*this   == tocheck.ptr); }
      int operator!= (dstring & tocheck) {return (!(*this == tocheck));    }
      int operator!= (char *tocheck)     {return (!(*this == tocheck));    }
      int operator<= (char *tocheck);
      int operator<= (dstring & tocheck) {return (*this   <= tocheck.ptr); }
      int operator<  (dstring & tocheck) {return (!(*this >= tocheck.ptr));}
      int operator<  (char *tocheck)     {return (!(*this >= tocheck));    }
      int operator>= (char *tocheck);
      int operator>= (dstring & tocheck) {return (*this   >= tocheck.ptr); }
      int operator>  (dstring & tocheck) {return (!(*this <= tocheck.ptr));}
      int operator>  (char *tocheck)     {return (!(*this <= tocheck));    }

      //-------------------------------------------------------------------
      // Indexzugriffs-Operatoren fr Array- und Pointerzugriff
      //-------------------------------------------------------------------
      char& operator[] (int idx);
      char* operator+ (int i);
      
      //-------------------------------------------------------------------
      // berladen der Stream-IO-Operatoren
      //-------------------------------------------------------------------
      friend ostream& operator<< (ostream& s, dstring z);
      friend istream& operator>> (istream& s, dstring &z);
};

#endif
