#ifndef _dstring_H_
#define _dstring_H_

class dstring
{
	//-----------------------------------------------------------------------
	// Member-Variablen, nach Mvglichkeit immer PRIVATE !
	//-----------------------------------------------------------------------

	private:
		char *ptr;

	//-----------------------------------------------------------------------
	// (Methoden) Member-Funktionen 
	//-----------------------------------------------------------------------

	private:
		long   len      (char *tocount) const;

	public:

		//--------------------------------------------------------------------
		// Constructoren und Destructor
		//--------------------------------------------------------------------
		 dstring ();	// Constructor
		 dstring (char *toset);
		 dstring (dstring & toset);
		~dstring ();

		//--------------------------------------------------------------------
		// Methoden
		//--------------------------------------------------------------------

		char *get     (void)          const {return (ptr);};
		char *set     (char *toset);
		long  length  (char *tocount) const {return (len (ptr));};
		char *concat  (char *toadd);
		char *lower   (void);
		char *upper   (void);
		char *ltrim   (void);
		char *rtrim   (void);
		char *alltrim (void);
		
		//-------------------------------------------------------------------
		// Operatoren
		//-------------------------------------------------------------------

		char *operator= (dstring & tocopy);
		char *operator= (char *tocopy);
		char *operator+ (dstring & tocopy);
		char *operator+ (char *tocopy);
		int operator== (char *tocheck);
		int operator== (dstring & tocheck) { return (*this == tocheck.ptr);    };
		int operator!= (dstring & tocheck) { return (!(*this == tocheck));     };
		int operator!= (char *tocheck)    { return (!(*this == tocheck));     };
		int operator<= (char *tocheck);
		int operator<= (dstring & tocheck) { return (*this <= tocheck.ptr);    };
		int operator<  (dstring & tocheck) { return (!(*this >= tocheck.ptr)); };
		int operator<  (char *tocheck)    { return (!(*this >= tocheck));     };
		int operator>= (char *tocheck);
		int operator>= (dstring & tocheck) { return (*this >= tocheck.ptr);    };
		int operator>  (dstring & tocheck) { return (!(*this <= tocheck.ptr)); };
		int operator>  (char *tocheck)    { return (!(*this <= tocheck));     };
};

#endif
